stages:
  - test
  - deploy

pages:
  stage: deploy
  image: ubuntu:22.04
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
    - apt update -qq
    - DEBIAN_FRONTEND=noninteractive apt install -y --no-install-recommends ca-certificates
      ccache wget curl build-essential git-core libjsoncpp-dev zip cmake automake libtool
      libxcb-shm0-dev libxrandr-dev libxi-dev libgsl0-dev libatlas3-base libgphoto2-dev
      libxinerama-dev libxcursor-dev python3-dev portaudio19-dev yasm libgl1-mesa-dev
      libopencv-dev libx264-dev libx265-dev doxygen python3-pip graphviz

    # CCache stuff
    - mkdir -p ccache
    - export CCACHE_BASEDIR=${PWD}
    - export CCACHE_DIR=${PWD}/ccache
    - export PATH="/usr/lib/ccache:${PATH}"
  script:
    # Build the website
    - pip install -U sphinx
    - pip install -r requirements.txt
    - make htmlgitlabdocs

    # Grab and build the API doc
    - git clone https://gitlab.com/splashmapper/splash splash-code
    - pushd splash-code
    - mkdir -p build && pushd build
    - cmake -DBUILD_CODE=OFF .. && make doc && cp -r docs/html ../../public/doxygen
    - popd
  artifacts:
    paths:
    - public
  
test:
  stage: test
  image: python:3.8
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  script:
    - pip install -U sphinx
    - pip install -r requirements.txt
    - make htmlgitlabdocs
  artifacts:
    paths:
    - public
  except:
    - main
